"""
DO NOT EDIT THIS FILE!!
This file is automatically generated by the process_schemas.py program
in the scripts directory. It is not intended to be edited directly. If
you need to update the GEL protocol classes, please run the script
on the appropriate schema version.
"""
from protocols.protocol import (
    ProtocolElement,
    avro_parse,
    load_schema,
)


class ExitQuestionnaireRD(ProtocolElement):
    """
    This is an entity to hold the information in
    org.gel.models.report.avro.RareDiseaseExitQuestionnaire in     a
    form compatible with CVA.
    """

    # load schema from file
    _schemaSource = load_schema(__file__)
    # parse into avro classes
    schema = avro_parse(_schemaSource)

    requiredFields = {
        "variants",
    }

    @classmethod
    def getEmbeddedTypes(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import cva as cva_1_0_0

        return {
            "variants": cva_1_0_0.ReportedVariantQuestionnaireRD,
        }

    @classmethod
    def getEmbeddedEnums(cls):
        return {}

    @classmethod
    def getEmbeddedByNamespace(cls):
        # import here to prevent circular imports in python 2.7.
        from protocols.protocol_6_1 import cva as cva_1_0_0

        return {
            "org.gel.models.cva.avro.ReportedVariantQuestionnaireRD": cva_1_0_0.ReportedVariantQuestionnaireRD,
            "org.gel.models.cva.avro.ExitQuestionnaireRD": cva_1_0_0.ExitQuestionnaireRD,
        }

    __slots__ = [
        "variants",
    ]

    def __init__(
        self,
        variants,
        validate=None,
        **kwargs
    ):
        """Initialise the cva_1_0_0.ExitQuestionnaireRD model.

        :param variants:
            The list variant group level questions (this list will be unwinded
            during ingestion)
        :type variants: list[ReportedVariantQuestionnaireRD]
        """

        attributes = {k: v for k, v in locals().items() if k not in ["self", "unknown"]}
        ProtocolElement.__init__(self, **attributes)

    @classmethod
    def _namespace_version(cls):
        return "1.0.0"
